//
//  ViewController.m
//  三级输第二种实现
//
//  Created by sjyx on 16/11/3.
//  Copyright © 2016年 sjyx. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()<UITableViewDelegate,UITableViewDataSource>
{
    BOOL _isOpen;//判断是否展开
    
    int _erjiNum;//展开了,菜单的数量为5,没有展开数量为0;
    NSInteger headerMark;//标记某个表头
    NSInteger indexPathNum;
    NSInteger rowMark;
    
    BOOL _isErJiOpen;//第二级是否展开
}
@property(nonatomic,retain)NSIndexPath *selectIndex;
@property(nonatomic,strong)UITableView *tableView;
@property(nonatomic,strong)UILabel *lab;
@property(nonatomic,strong)NSMutableArray *headerArr;
@end


@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    _selectIndex=nil;
    _isOpen=YES;
    _headerArr=[NSMutableArray array];
    // Do any additional setup after loading the view, typically from a nib.
    _tableView=[[UITableView alloc]initWithFrame:CGRectMake(0, 0, 300, self.view.bounds.size.height) style:UITableViewStylePlain];
    _tableView.backgroundColor=[UIColor redColor];
    
    _tableView.delegate=self;
    _tableView.dataSource=self;
    
    [self.view addSubview:_tableView];
}
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    if (section==headerMark) {
        return _erjiNum;
    }
    return 0;
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    //判断cell是否处于选中状态，并且用不同的identifier标记重用;
    if (indexPath.section==self.selectIndex.section&&indexPath.row==self.selectIndex.row&&self.selectIndex!=nil) {//选中状态
        static NSString *indentifier=@"cell";
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:indentifier];
        if (cell==nil) {
            cell=[[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:indentifier];

            UIScrollView *sv= [[UIScrollView alloc]initWithFrame:CGRectMake(0, 100, 300, 200)];
            sv.backgroundColor=[UIColor redColor];
            sv.userInteractionEnabled=YES;
            sv.contentSize=CGSizeMake(300,5+40*9+5);
            [cell.contentView addSubview:sv];
            for (int i=0; i<10; i++) {
                //贴在底层view上的一个btn
                UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
                btn.frame=CGRectMake(0, 5+(5+40)*i, self.view.bounds.size.width, 40);
                btn.backgroundColor = [UIColor blueColor];
                [btn addTarget:self action:@selector(openOtherTableView) forControlEvents:UIControlEventTouchUpInside];
                [btn setTitle:@"这是第三层" forState: UIControlStateNormal];
                [sv addSubview:btn];
            }
            UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(10, 10, 300, 30)];
//            label.text=@"这个是第三层";
            label.tag = 10;
            [cell.contentView addSubview:label];
          
        }
        cell.selectionStyle=UITableViewCellSelectionStyleNone;
        UILabel *label = (UILabel*)[cell.contentView viewWithTag:10];
        label.text = [NSString stringWithFormat:@"这是第二层的%ld栏",indexPath.row];
        return cell;
        
    }
    else//非选中状态
    {
       
        static NSString *identifier = @"Cell";
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:identifier];
        if (cell==nil) {
            cell=[[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:identifier];
            UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(10, 10, 300, 30)];
            label.tag = 10;
            [cell.contentView addSubview:label];
        }
        cell.selectionStyle=UITableViewCellSelectionStyleNone;
        UILabel *label = (UILabel*)[cell.contentView viewWithTag:10];
        label.text = [NSString stringWithFormat:@"这是第二层的%ld栏",indexPath.row];
        return cell;
    }
    return nil;
    
}
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{

    [tableView deselectRowAtIndexPath:indexPath animated:YES];

    if (!self.selectIndex) {
        self.selectIndex=indexPath;
        NSIndexPath *indexpath=[NSIndexPath indexPathForRow:self.selectIndex.row inSection:indexPath.section];
        [tableView reloadRowsAtIndexPaths:[NSArray arrayWithObject:indexpath] withRowAnimation:UITableViewRowAnimationAutomatic];
    }
    else
    {
        BOOL selectTheSameRow = indexPath.row==self.selectIndex.row?YES:NO;
        BOOL selectTheSameSection = indexPath.section==self.selectIndex.section?YES:NO;
        //两次点击不同的cell
        if (!selectTheSameRow||!selectTheSameSection) {
            //收起上次点击展开的cell
            NSIndexPath *tempIndexPath = [self.selectIndex copy];
            self.selectIndex=nil;
            NSIndexPath *indexpath=[NSIndexPath indexPathForRow:tempIndexPath.row inSection:indexPath.section];
            [tableView reloadRowsAtIndexPaths:[NSArray arrayWithObject:indexpath] withRowAnimation:UITableViewRowAnimationAutomatic];
            //展开新的选择的cell
            self.selectIndex=indexPath;
            NSIndexPath *indexpath1=[NSIndexPath indexPathForRow:self.selectIndex.row inSection:indexPath.section];
            [tableView reloadRowsAtIndexPaths:[NSArray arrayWithObject:indexpath1] withRowAnimation:UITableViewRowAnimationAutomatic];
        }
        else
        {
            self.selectIndex=nil;
            [tableView reloadRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationAutomatic];
        }
    }
    [_tableView scrollToRowAtIndexPath:indexPath atScrollPosition:UITableViewScrollPositionNone animated:YES];
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    if (indexPath.section==self.selectIndex.section&& indexPath.row==self.selectIndex.row&&self.selectIndex!=nil) {
        return 300;
    }
    return 100;
}
-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 5;//总共多少组
}
-(UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section
{
    
    //在headerview上添加按钮
        UIView *headerView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, 300, self.view.bounds.size.height/5)];
        headerView.backgroundColor = [UIColor greenColor];
        //在header上添加按钮
        UIButton *headerBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        headerBtn.frame =CGRectMake(0, 2, 300, self.view.bounds.size.height/5);
        headerBtn.backgroundColor = [UIColor blueColor];
        headerBtn.alpha=0.5;
        [headerBtn setTitle:[NSString stringWithFormat:@"这是第-层的第%ld按钮",section] forState:UIControlStateNormal];
        [headerView addSubview:headerBtn];
        [headerBtn addTarget:self action:@selector(chooseHeaderView:) forControlEvents:UIControlEventTouchUpInside];
        headerBtn.tag=section;
    
     [_headerArr addObject:headerView];
    return headerView;
   

}
-(CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
{
  
        return self.view.bounds.size.height/5;
 
}
-(void)openOtherTableView
{
    NSLog(@"我去你妈的!!!");
}
-(void)chooseHeaderView:(id)sender
{
    
    UIButton *btn = (UIButton *)sender;
    
    if (_isOpen==YES) {
        _erjiNum=5;
        _isOpen=NO;
    }
    else if (_isOpen==NO)
    {
        _erjiNum=0;
        _isOpen=YES;
    }
    headerMark=btn.tag;
    [_tableView reloadData];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
